/*******************************************************************
*
*  DESCRIPTION: Simulator::registerNewAtomics()
*
*  AUTHOR: Amir Barylko & Jorge Beyoglonian 
*
*  EMAIL: mailto://amir@dc.uba.ar
*         mailto://jbeyoglo@dc.uba.ar
*
*  DATE: 27/6/1998
*
*******************************************************************/

#include "modeladm.h" 
#include "mainsimu.h"
#include "queue.h"      // class Queue
#include "generat.h"    // class Generator
#include "cpu.h"        // class CPU
#include "trafico.h"    // class Trafico
#include "transduc.h"    // class Transducer
#include "congest.h"    // class congestion
#include "contador.h"    // class contador
#include "od.h"    // class od

#include "tscgenerator.h"    
#include "tscconsumer.h" 
#include "tscsincrotrafficlight.h" 
#include "tsctrafficlight.h" 
#include "tscsincrorailnet.h" 
#include "tscrailnet.h"
#include "tsccounter.h"

void MainSimulator::registerNewAtomics()
{
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Queue>() , "Queue" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Generator>() , "Generator" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<CPU>() , "CPU" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Trafico>() , "Trafico" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<congestion>() , "congestion" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<od>() , "od" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Transducer>() , "Transducer" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<contador>() , "contador" ) ;

	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<TSCGenerator>() , "TSCGenerator" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<TSCConsumer>() , "TSCConsumer" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<TSCSincroTrafficLight>() , "TSCSincroTrafficLight" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<TSCTrafficLight>() , "TSCTrafficLight" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<TSCSincroRailnet>() , "TSCSincroRailnet" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<TSCRailnet>() , "TSCRailnet" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<TSCCounter>() , "TSCCounter" ) ;

}
