/*******************************************************************
*
*  DESCRIPTION: class Contador
*
*  AUTHOR: 
*
*  DATE: 
*
*******************************************************************/

#ifndef __COUNTER_H
#define __COUNTER_H

#include <map.h>
#include "atomic.h"
#include "message.h"

class TSCCounter: public Atomic
{
public:
	TSCCounter( const string &name = "TSCCounter" ) ;	//Default constructor

	virtual string className() const ;

protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &arrived ;
	const Port &solved ;

	Port &throughputA;
	Port &throughputS;
      

	Time frec ;
	Time tUnit ;
	long arrivedCount ;
	long solvedCount ;

	const Time &frecuence() const ;
	const Time &timeUnit() const ;

};	// class Contador

// ** inline ** // 
inline
string TSCCounter::className() const
{
	return "TSCCounter" ;
}

inline
const Time &TSCCounter::frecuence() const
{
	return frec ;
}


inline
const Time &TSCCounter::timeUnit() const
{
	return tUnit ;
}

#endif   //__COUNTER_H 
