#ifndef __TSCTRAFFICLIGHT_H
#define __TSCTRAFFICLIGHT_H

/** include files **/
#include "atomic.h"     // class Atomic
#include "except.h"     // class InvalidMessageException
#include <map.h>
#include <string>


/** declarations **/
class TSCTrafficLight : public Atomic
{
public:
	TSCTrafficLight( const string &name = "TSCTrafficLight" );	  // Default constructor

	~TSCTrafficLight();

	virtual string className() const
		{return "TSCTrafficLight";}

protected:
	Model &initFunction() ;

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
      int lanes;
      int color;  // 0 = green light, 1 = red light
      Port &x_si_luz;
      Port &x_t_luz;
	map<int,Port*> y_t_luz;
			
};	// class TSCTrafficLight


#endif   //__TSCTRAFFICLIGHT_H 
