#ifndef __TSCGENERATOR_H
#define __TSCGENERATOR_H

/** include files **/
#include "atomic.h"     // class Atomic
#include "atomicstate.h"
#include "except.h"     // class InvalidMessageException
#include <map.h>
#include <string>
//#include "distri.h"

/** forward declarations **/
class Distribution ;

/** declarations **/
class TSCGenerator : public Atomic
{
public:
	TSCGenerator( const string &name = "TSCGenerator" );	  // Default constructor

	~TSCGenerator();

	virtual string className() const
		{return "TSCGenerator";}

protected:
	Model &initFunction() ;

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
      int lanes;
      int lane;
	map<int,Port*> y_t_hayauto;

	Distribution *dist ;
	Distribution &distribution()
			{return *dist;}
			
};	// class TSCGenerator


#endif   //__TSCGENERATOR_H 
