#ifndef __TSCSINCROTRAFFICLIGHT_H
#define __TSCSINCROTRAFFICLIGHT_H

/** include files **/
#include "atomic.h"     // class Atomic
#include "except.h"     // class InvalidMessageException
#include <map.h>
#include <string>

/** forward declarations **/
class Distribution ;

/** declarations **/
class TSCSincroTrafficLight : public Atomic
{
public:
	TSCSincroTrafficLight( const string &name = "TSCSincroTrafficLight" );	  // Default constructor

	~TSCSincroTrafficLight();

	virtual string className() const
		{return "TSCSincroTrafficLight";}

protected:
	Model &initFunction() ;

	Model &externalFunction( const ExternalMessage & );

	Model &internalFunction( const InternalMessage & );

	Model &outputFunction( const InternalMessage & );

private:
      int tlights;
      int tlight;
	map<int,Port*> y_se_luz;

	Distribution *dist ;
	Distribution &distribution()
			{return *dist;}
			
};	// class TSCSincroTrafficLight


#endif   //__TSCSINCROTRAFFICLIGHT_H 
