%{
#include <stdio.h>
#include <istream.h>
#include <string>
#include "texception.h"
#include "codestruct.h"
#include "template.h"
#include "ruleblock.h"
#define YYDEBUG 1
#define YYERROR_VERBOSE 1

extern int errorline;
extern CodeStruct codeStruct;
Template         *se;
string            saux;
string            type;
list<string>     *ssaux;
RuleBlock        *raux;
Macro            *maux;
int               yyerror(char *s);
int               yylex(void);
int               dummyini;
string getBeginMacroName(string);
%}

%union {
        int   i;
        char *s;
       }

%type <s> CODESTRUCT
%type <s> LIST_TEMPLATES TEMPLATE 
%type <s> LIST_ANY_LINES LIST_LINES LIST_NOTHING

%type <s> TOP_COMPONENTS
%type <s> TOP_LINKS
%type <s> BEFORE_NEIGHBORS
%type <s> NEIGHBORS
%type <s> BEFORE_PORTS
%type <s> PORTS
%type <s> BEFORE_LINKS
%type <s> LINKS
%type <s> BEFORE_ZONES
%type <s> ZONES
%type <s> BEFORE_RULES
%type <s> RULES
%type <s> AFTER_RULES
%type <s> LIST_RULEBLOCKS 
%type <s> RULEBLOCK 
%type <s> LIST_MACROS 
%type <s> MACROS 
%type <s> MACRO

%token <s> TOK_TEMPLATE
%token <s> TOK_ENDTEMPLATE      
%token <s> TOK_TOP_COMPONENTS
%token <s> TOK_TOP_LINKS
%token <s> TOK_BEFORE_NEIGHBORS
%token <s> TOK_NEIGHBORS
%token <s> TOK_BEFORE_PORTS
%token <s> TOK_PORTS
%token <s> TOK_BEFORE_LINKS
%token <s> TOK_LINKS
%token <s> TOK_BEFORE_ZONES
%token <s> TOK_ZONES
%token <s> TOK_BEFORE_RULES
%token <s> TOK_RULES
%token <s> TOK_AFTER_RULES
%token <s> TOK_BLOCK
%token <s> TOK_LINE
%token <s> TOK_ERROR         
%token <s> TOK_MACROS
%token <s> TOK_END_MACROS
%token <s> TOK_BEGIN_MACRO
%token <s> TOK_END_MACRO
  
%%


CODESTRUCT      :LIST_TEMPLATES MACROS   
                ;

LIST_TEMPLATES  :TEMPLATE                //{cout << "entro por unico templates\n";}
                |LIST_TEMPLATES TEMPLATE  //{cout << "entro por lista templates\n";}
                ;

TEMPLATE         :                      
                LIST_NOTHING 
                TOK_TEMPLATE             {se = new Template;se->setName(strdup($2));}
                                         //{cout << "detecto el template "<<strdup($2)<<"\n";}                                        
                TOP_COMPONENTS           //{cout << "termino de procesar top components\n";}
                TOP_LINKS                //{cout << "termino de procesar top links\n";}
                BEFORE_NEIGHBORS         //{cout << "termino procesar before neighbors\n";}
                NEIGHBORS                //{cout << "termino procesar neighbors\n";}
                BEFORE_PORTS             //{cout << "termino procesar before ports\n";}
                PORTS                    //{cout << "termino procesar ports\n";}
                BEFORE_LINKS             //{cout << "termino procesar before links\n";}
                LINKS                    //{cout << "termino procesar links\n";}
                BEFORE_ZONES             //{cout << "termino procesar before zones\n";}
                ZONES                    //{cout << "termino procesar zones\n";}
                BEFORE_RULES             //{cout << "termino procesar before rules\n";}
                RULES                    //{cout << "termino procesar rules\n";}
                AFTER_RULES              //{cout << "termino procesar after rules\n";}
                TOK_ENDTEMPLATE          {codeStruct.addTemplate(se);
                                         // cout << "termino de procesar template\n";
                                         }
                ;
                

TOP_COMPONENTS    :                              {dummyini=1;}
                  |TOK_TOP_COMPONENTS  {ssaux = se->getTopComponents();} 
                   LIST_ANY_LINES 
                  ;

TOP_LINKS         :                              {dummyini=1;}
                  |TOK_TOP_LINKS       {ssaux = se->getTopLinks();} 
                   LIST_ANY_LINES 
                  ;

BEFORE_NEIGHBORS  :                              {dummyini=1;}
                  |TOK_BEFORE_NEIGHBORS          {ssaux = se->getBeforeNeighbors();} 
                   LIST_ANY_LINES
                  ;

NEIGHBORS         :                              {dummyini=1;}
                  |TOK_NEIGHBORS                 {ssaux = se->getNeighbors();} 
                   LIST_ANY_LINES
                  ;

BEFORE_PORTS      :                              {dummyini=1;}
                  |TOK_BEFORE_PORTS              {ssaux = se->getBeforePorts();} 
                   LIST_ANY_LINES
                  ;

PORTS             :                              {dummyini=1;}
                  |TOK_PORTS                     {ssaux = se->getPorts();} 
                   LIST_ANY_LINES
                  ;

BEFORE_LINKS      :                              {dummyini=1;}
                  |TOK_BEFORE_LINKS              {ssaux = se->getBeforeLinks();} 
                   LIST_ANY_LINES
                  ;

LINKS             :                              {dummyini=1;}
                  |TOK_LINKS                     {ssaux = se->getLinks();} 
                   LIST_ANY_LINES
                  ;

BEFORE_ZONES      :                              {dummyini=1;}
                  |TOK_BEFORE_ZONES              {ssaux = se->getBeforeZones();} 
                   LIST_ANY_LINES
                  ;

ZONES             :                              {dummyini=1;}
                  |TOK_ZONES                     {ssaux = se->getZones();} 
                   LIST_ANY_LINES
                  ;

BEFORE_RULES      :                              {dummyini=1;}
                  |TOK_BEFORE_RULES              {ssaux = se->getBeforeRules();} 
                   LIST_ANY_LINES                     
                  ;

RULES             :                              {dummyini=1;}
                  |TOK_RULES                   
                   LIST_RULEBLOCKS
                  ;


LIST_RULEBLOCKS :                              {dummyini=1;}
                |LIST_RULEBLOCKS RULEBLOCK  
                ;

RULEBLOCK       :TOK_BLOCK      {//cout <<"detecto tok_ruleblock\n";
                                 raux = new RuleBlock;
                                 ssaux = raux->getRules();
                                 ssaux->push_back(strdup($1));}
                LIST_LINES      {se->addRules(raux);}
                ;


AFTER_RULES       :                              {dummyini=1;}
                  |TOK_AFTER_RULES               {ssaux = se->getAfterRules();} 
                   LIST_ANY_LINES                     
                  ;
MACROS          :                            {dummyini=1;}
                |LIST_NOTHING           
                 TOK_MACROS                  //{cout << "comienza procesar macros\n";}
                 LIST_MACROS 
                 LIST_NOTHING                
                 TOK_END_MACROS             // {cout << "termino procesar macros\n";}
                 LIST_NOTHING              
                ;


LIST_MACROS     :                  {dummyini=1;}
                |LIST_MACROS MACRO                      
                ;

MACRO           :LIST_NOTHING
                 TOK_BEGIN_MACRO        {//cout<< "detecto macro\n";
                                         maux = new Macro;
                                         maux->setName(getBeginMacroName(strdup($2)));
                                         ssaux = maux->getLines();
                                         ssaux->push_back(strdup($2));}
                 LIST_LINES            
                 TOK_END_MACRO          {ssaux->push_back(strdup($5));
                                         codeStruct.addMacro(maux);
                                        // cout<< "fin macro\n";
                                        }
                ;


LIST_ANY_LINES  :                            {dummyini=1;}
                |LIST_ANY_LINES TOK_LINE         { ssaux->push_back(strdup($2));}
                |LIST_ANY_LINES TOK_BLOCK        { ssaux->push_back(strdup($2));}
                ;

LIST_LINES      :TOK_LINE                     { ssaux->push_back(strdup($1));}
                |LIST_LINES TOK_LINE         { ssaux->push_back(strdup($2));}
                ;

LIST_NOTHING    :                        {dummyini=1;}
                |LIST_NOTHING TOK_LINE   
                ;


%%


int yyerror(char *s){
/*********
#define YYERROR_VERBOSE 1                   para que el error sea mas detallado
%token <s> TOK_IDENTIF  "identifier"        "identifier" es lo que escribe si es lo que est esperando
*******/
char m[512];
sprintf(m,"line #: %d --> %s not expected",errorline, yylval.s);
throw TException(s,strdup(m));
}

#include "functionname.h"
