#ifndef __RAILNET_H
#define __RAILNET_H

#include <istream>
#include <list>
#include <utility>
#include <string>
#include "segment.h"

//forward declarations
class Segment;

class Railnet {
public:
    void      setIdent(std::string);
    void      setDelay(int);
    std::string    getIdent();
    int       getDelay();
    void      addRail(Segment*,int);        
    int       findDistance(std::string);     //receives identifier and gives the distance     
    int       findRailOrder(std::string);    //receives identifier and gives the rail order number
    void      print();                 //print the point info to the stdin
    std::list< std::pair<Segment*, int> >* getLRail();
    int       getQsegs();
protected:
    std::string    ident;
    int       delay;
    std::list< std::pair<Segment*, int> > lRail;
private:
};


#endif /* __RAILNET_H */
