#ifndef __TEMPLATE_H
#define __TEMPLATE_H

#include <list>
#include <string>
#include "ruleblock.h"

//forward declarations
class RuleBlock;

class Template{
public:
    void print();               //print all the info to the stdin  
    std::string getName();
    void setName(std::string);
    bool getWasUsed();
    void setWasUsed(bool);
    void addTopComponents(std::string c);
    void addTopLinks(std::string c);
    void addBeforeNeighbors(std::string c);
    void addNeighbors(std::string c);
    void addBeforePorts(std::string c);
    void addPorts(std::string c);
    void addBeforeLinks(std::string c);
    void addLinks(std::string);
    void addBeforeZones(std::string);
    void addZones(std::string);
    void addBeforeRules(std::string);
    void addRules(RuleBlock*);
    void addAfterRules(std::string);
    std::list<std::string>* getTopComponents();
    std::list<std::string>* getTopLinks();
    std::list<std::string>* getBeforeNeighbors();
    std::list<std::string>* getNeighbors();
    std::list<std::string>* getBeforePorts();
    std::list<std::string>* getPorts();
    std::list<std::string>* getBeforeLinks();
    std::list<std::string>* getLinks();
    std::list<std::string>* getBeforeZones();
    std::list<std::string>* getZones();
    std::list<std::string>* getBeforeRules();
    std::list<RuleBlock>* getRules();
    std::list<std::string>* getAfterRules();

protected:
    std::string       name;
    bool         wasUsed;
    std::list<std::string> topComponents;
    std::list<std::string> topLinks;
    std::list<std::string> beforeNeighbors;
    std::list<std::string> neighbors;  
    std::list<std::string> beforePorts;
    std::list<std::string> ports;  
    std::list<std::string> beforeLinks;  
    std::list<std::string> links;  
    std::list<std::string> beforeZones;
    std::list<std::string> zones;  
    std::list<std::string> beforeRules;
    std::list<RuleBlock> rules;  
    std::list<std::string> afterRules;  
private:
};

#endif /* __TEMPLATE_H */
