	#ifndef __TRAFFIC_H
#define __TRAFFIC_H

#include <fstream>
#include <list>
#include <map>
#include <string>
#include "segment.h"
#include "crossing.h"
#include "texception.h"

//forward declarations
class Segment;
class Crossing;
class TException;


class Traffic {
public:
    void      addSeg(Segment*);        //add segment to simulation
    void      addRailnet(Railnet*);    //add railnet to simulation
    void      addCross(Crossing*);     //add crossing to simulation 
    Segment  *findSeg(std::string);         //receives identifier and gives the segment 
    void      print();                 //print all the simulation info to the stdin    
    void      validate();              // validate the simulation info
    std::list<Segment*>* getLSeg();         //get all the segments in the simulation        
    std::list<Railnet*>* getLRailnet();     //get all the railnets in the simulation        
    std::map<Point, Crossing*>* getMCross();       //get all the crossing in the simulation    

protected:
    std::list<Segment*>  lSeg;              // list of segments in the simulation
    std::list<Railnet*>  lRailnet;          // list of railnets in the simulation
    std::map<Point,Crossing*> mCross;       // list of crossings in the simulation
private:
    void      printSegments();         //print the segments info to the stdin    
    void      printCrossings();        //print the crossing info to the stdin  
    void      printRailnet();          //print the railnet info to the stdin  
};

#endif /* __TRAFFIC_H */
