#ifndef __CODEGEN_H
#define __CODEGEN_H

#include <fstream.h>
#include <list.h>
#include <map.h>
#include <string>
#include "traffic.h"
#include "segment.h"
#include "crossing.h"
#include "texception.h"
#include "codestruct.h"
#include "lineconvertor.h"
#include "template.h"
#include "ruleblock.h"
#include "macro.h"
#include "templatename.h"
#include "fileadmin.h"
#include "functionname.h"

//forward declarations
class Traffic;
class Segment;
class Crossing;
class TException;
class CodeStruct;
class LineConvertor;
class Template;
class RuleBlock;
class Macro;
class ModelName;
class FileAdmin;



extern CodeStruct codeStruct;
extern FileAdmin fileAdmin;
extern Traffic traffic;

class CodeGen {
public:
    void      generate();              // generate the code for the simulator

protected:
private:
    void      generateSegment(Segment*);  
    void      generateLineSegmentCall(Segment*,string);  
    void      generateRuleSegmentCall(Segment*,string);  
    void      generateLineSegment(Segment*,list<string>*,string);  
    void      generateLineHole(Hole*,list<string>*,string);  
    void      generateLineJobsite(Jobsite*,list<string>*,string);  
    void      generateLineCtrElem(CtrElem*,list<string>*,string);  
    void      generateLineRail(Segment*,Railnet*,list<string>*,string);  
    void      generateCrossing(Crossing*);  
    void      generateLineCrossingCall(Crossing*,string);  
    void      generateRuleCrossingCall(Crossing*,string);  
    void      generateLineCrossing(Crossing*,list<string>*,string);
    void      generateRailnet(Railnet*);  
    void      generateLineRailnet(Railnet*,list<string>*,string);
//*********    void      generateLine(list<string>*,string);  
    list<string>* (Template::*call)();
    void      clearDepWasUsed();
};

#endif /* __CODEGEN_H */
