#include <iostream.h>
#include "codestruct.h"

void CodeStruct::addTemplate(Template* m){
mTemplate.insert(std::map<std::string,Template>::value_type(m->getName(),*m));
}

Template* CodeStruct::getTemplate(std::string c){
std::map<std::string,Template>::iterator s;
s = mTemplate.find(c);
if (s == mTemplate.end()){
    std::string m = "Template specification not found: ";
    m += c;
    throw TException("getTemplate",m);
    }    
return &(s->second);
} 

std::map<std::string, Template>* CodeStruct::getMTemplate(){
return &mTemplate;}

void CodeStruct::addMacro(Macro* m){
mMacro.insert(std::map<std::string,Macro>::value_type(m->getName(),*m));
}

Macro* CodeStruct::getMacro(std::string c){
std::map<std::string,Macro>::iterator s;
s = mMacro.find(c);
if (s == mMacro.end()){
    std::string m = "Macro specification not found: ";
    m += c;
    throw TException("getMacro",m);
    }    
return &(s->second);
} 

std::map<std::string, Macro>* CodeStruct::getMMacro(){
return &mMacro;}


void CodeStruct::print(){               //print all the info to the stdin    
   cout << "\nCode info\n";
   std::map<std::string,Template>::iterator   iter;
   std::map<std::string,Macro>::iterator   iter2;
   if (this->mTemplate.size()!= 0) {
   cout << "\nList of Templates\n";
   for (iter = mTemplate.begin(); iter != mTemplate.end(); iter++)
       { iter->second.print();cout << "\n"; };
   }

   if (this->mMacro.size()!= 0) {
   cout << "\nList of Macros\n";
   for (iter2 = mMacro.begin(); iter2 != mMacro.end(); iter2++)
       { iter2->second.print();cout << "\n"; };
   }

}
